#declare ScaffoldArr_debug = 0;


#if(ScaffoldArr_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 6;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/4, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <1000, 2000, 3000>;


#declare G_debug = 0;
#declare G_debug_L = 10;
#declare G_debug_R = 0.016;

#include "FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
#debug  "\n "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug    " ScaffoldArr is set for debug "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro ScaffoldArrMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt, p_m, p_Num)


//-----------------------------------------
// Var 

#local m = p_m;

#local secW = 3*m; 
#local secH = 2.25*m; 
#local secT = 1.25*m; 

#local BlockW = p_W; //22*m;
#local BlockH = p_H; //10*m;
#local BlockT = p_T; //10*m;

#local numW = floor((BlockW+secT)/secW);
#local numH = p_Num;
#local numT = floor((BlockT+secT)/secW);

#local OddSecW = BlockW+secT-numW*secW;

#local OddSecT = BlockT+secT-numT*secW;


//------------------------------------------------------
// Stair Section

   #include "SkyScaffoldStair_v03.Inc"

#local l_Txt = texture{ pigment{rgb .71} }
#local l_DoTxt = 0;

#local SkyScaffoldStairObj =
/*
#local bV = <secW*.9, secH*.1, secT*.9>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>  texture{ pigment{blue 1} } }
*/

SkyScaffoldStairMac
      (secW, secH, secT,
       0, 0, 0,
       l_Txt, l_DoTxt, numH/2)

//------------------------------------------------------
// Plain Section


   #include "SkyScaffoldv02.Inc"


#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{rgb .71} }
#local l_DoTxt = 0;

#local SkyScaffoldObj =

/*
#local bV = <secW*.9, secH*.1, secT*.9>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>}
*/

SkyScaffoldStairMac
      (secW, secH, secT,
       0, 0, 0,
       l_Txt, l_DoTxt, numH/2)




#local l_Txt = texture{ pigment{rgb .71} }
#local l_DoTxt = 0;

#local OddWSkyScaffoldObj =

SkyScaffoldStairMac
      (OddSecW+.1*m, secH, secT,
       0, 0, 0,
       l_Txt, l_DoTxt, numH/2)


/*

#local bV = <OddSecW*.9, secH*.1, secT*.9>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>  texture{ pigment{green .971} } }
*/


#local l_Txt = texture{ pigment{rgb .71} }
#local l_DoTxt = 0;

#local OddTSkyScaffoldObj =

SkyScaffoldStairMac
      (OddSecT+.1*m, secH, secT,
       0, 0, 0,
       l_Txt, l_DoTxt, numH/2)


/*
#local bV = <OddSecT*.9, secH*.1, secT*.9>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>  texture{ pigment{green .971} } }
*/


//-----------------------------------------
// Main 

 union{

// debug core
#local bV = <BlockW, .1*m, BlockT>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
//box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>  texture{ pigment{red 1} } }




// width
#local Count = numW-2;
#local I = 0;
#while ( I <= Count )

object{ SkyScaffoldObj translate<-secW/2+BlockW/2,  0,  BlockT/2+secT/2> + <-secW*I, 0, 0> } 
object{ SkyScaffoldObj translate<-secW/2+BlockW/2,  0,  BlockT/2+secT/2> + <-secW*I, 0, 0> rotate y*180 } 
#local I = I + 1;
#end

object{ OddWSkyScaffoldObj translate<-secW/2+BlockW/2,  0,  BlockT/2+secT/2> + <-secW*(numW-1 - .5) - OddSecW/2, 0, 0> } 
object{ SkyScaffoldStairObj translate<-secW/2+BlockW/2,  0,  BlockT/2+secT/2> + <-secW*(numW-1 - .5) - OddSecW-secW/2, 0, 0> } 

object{ OddWSkyScaffoldObj translate<-secW/2+BlockW/2,  0,  BlockT/2+secT/2> + <-secW*(numW-1 - .5) - OddSecW/2, 0, 0>  rotate y*180 } 
object{ SkyScaffoldStairObj translate<-secW/2+BlockW/2,  0,  BlockT/2+secT/2> + <-secW*(numW-1 - .5) - OddSecW-secW/2, 0, 0>    rotate y*180 } 


// depth
#local Count = numT-2;
#local I = 0;
#while ( I <= Count )

object{ SkyScaffoldObj rotate y*90 translate<secT/2+BlockW/2,  0,  -BlockT/2+secW/2> + <0, 0, secW*I> } 
object{ SkyScaffoldObj rotate y*90 translate<secT/2+BlockW/2,  0,  -BlockT/2+secW/2> + <0, 0, secW*I> rotate y*180 }

#local I = I + 1;
#end

object{ OddTSkyScaffoldObj rotate y*90 translate<secT/2+BlockW/2,  0,  -BlockT/2+secW/2> + <0, 0, secW*I-secW/2+OddSecT/2> } 
object{ OddTSkyScaffoldObj rotate y*90 translate<secT/2+BlockW/2,  0,  -BlockT/2+secW/2> + <0, 0, secW*I-secW/2+OddSecT/2> rotate y*180 } 


object{ SkyScaffoldStairObj rotate y*90 translate<secT/2+BlockW/2,  0,  -BlockT/2+secW/2> + <0, 0, secW*I-secW/2+OddSecT/2+secW/2+OddSecT/2> } 
object{ SkyScaffoldStairObj rotate y*90 translate<secT/2+BlockW/2,  0,  -BlockT/2+secW/2> + <0, 0, secW*I-secW/2+OddSecT/2+secW/2+OddSecT/2> rotate y*180 } 





      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(ScaffoldArr_debug)


#local l_m = .4;

#local l_W = 19*l_m;
#local l_H = 6*l_m;
#local l_T = 11*l_m;

#local l_Txt = texture{ pigment{rgb .6} }
#local l_DoTxt = 1;

#local l_Num = 8;

#local ScaffoldArrObj =
ScaffoldArrMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt, l_m, l_Num)

object{ ScaffoldArrObj  rotate y*-0 } 


#local bW = 2000;
#local bH = -2;
#local bT = 2000;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>
	texture{ pigment {rgb .8 }  finish{ ambient .25 diffuse .75 }  }
    }



#end

/******************************************************/
/*
The Call


   #include "ScaffoldRW_v01p.Inc"

#local l_m = .4;

#local l_W = 19*l_m;
#local l_H = 6*l_m;
#local l_T = 11*l_m;

#local l_Txt = texture{ pigment{rgb .6} }
#local l_DoTxt = 1;

#local l_Num = 8;

#local ScaffoldArrObj =
ScaffoldArrMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt, l_m, l_Num)

object{ ScaffoldArrObj  rotate y*-0 } 


#local bW = 2000;
#local bH = -2;
#local bT = 2000;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>
	texture{ pigment {rgb .8 }  finish{ ambient .25 diffuse .75 }  }
    }


*/
/*******************************************************/
